diff --git a/modules/DiWheelDrive_1-2/module.c b/modules/DiWheelDrive_1-2/module.c
index 6cb2f6d..4242041 100644
--- a/modules/DiWheelDrive_1-2/module.c
+++ b/modules/DiWheelDrive_1-2/module.c
@@ -24,7 +24,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#include "module.h"
+#include <amiroos.h>
+
+#include <string.h>
 
 /*===========================================================================*/
 /**
@@ -349,6 +351,67 @@ ROMCONST char* moduleShellPrompt = "DiWheelDrive";
  */
 /*===========================================================================*/
 
+#if ((AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MSI == true)) || defined(__DOXYGEN__)
+
+/* some local definitions */
+// maximum number of bytes per CAN frame
+#define CAN_BYTES_PER_FRAME                     8
+// identifier (as dominant as possible)
+#define MSI_BCBMSG_CANID                        0
+
+aos_ssspbcbstatus_t moduleSsspBcbTransmit(const uint8_t* buffer, size_t length)
+{
+  aosDbgCheck(buffer != NULL);
+  aosDbgCheck(length > 0 && length <= CAN_BYTES_PER_FRAME);
+
+  // local variables
+  CANTxFrame frame;
+
+  // setup the common parts of the message frame
+  frame.DLC = (uint8_t)length;
+  frame.RTR = CAN_RTR_DATA;
+  frame.IDE = CAN_IDE_STD;
+  frame.SID = MSI_BCBMSG_CANID;
+  memcpy(frame.data8, buffer, length);
+
+  // sent the frame and return
+  return (canTransmitTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, TIME_IMMEDIATE) == MSG_OK) ? AOS_SSSP_BCB_SUCCESS : AOS_SSSP_BCB_ERROR;
+}
+
+aos_ssspbcbstatus_t moduleSsspBcbReceive(uint8_t* buffer, size_t length)
+{
+  aosDbgCheck(buffer != NULL);
+  aosDbgCheck(length > 0 && length <= CAN_BYTES_PER_FRAME);
+
+  // local variables
+  CANRxFrame frame;
+
+  // receive a frame and check for errors
+  if (canReceiveTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, TIME_IMMEDIATE) == MSG_OK) {
+    // a correct frame was received
+    if (frame.DLC == length &&
+        frame.RTR == CAN_RTR_DATA &&
+        frame.IDE == CAN_IDE_STD &&
+        frame.SID == MSI_BCBMSG_CANID) {
+      // success: fetch the data and return
+      memcpy(buffer, frame.data8, length);
+      return AOS_SSSP_BCB_SUCCESS;
+    }
+    // an unexpected frame was received
+    else {
+      return AOS_SSSP_BCB_INVALIDMSG;
+    }
+  } else {
+    // failure: return with error
+    return AOS_SSSP_BCB_ERROR;
+  }
+}
+
+#undef MSI_BCBMSG_CANID
+#undef CAN_BYTES_PER_FRAME
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MSI == true) */
+
 /** @} */
 
 /*===========================================================================*/
diff --git a/modules/DiWheelDrive_1-2/module.h b/modules/DiWheelDrive_1-2/module.h
index a40e0e3..ef09b62 100644
--- a/modules/DiWheelDrive_1-2/module.h
+++ b/modules/DiWheelDrive_1-2/module.h
@@ -368,35 +368,14 @@ extern ROMCONST char* moduleShellPrompt;
  */
 /*===========================================================================*/
 
-/**
- * @brief   PD signal GPIO.
- */
-#define moduleSsspGpioPD                        moduleGpioSysPd
-
-/**
- * @brief   S signal GPIO.
- */
-#define moduleSsspGpioS                         moduleGpioSysSync
+#define moduleSsspSignalPD()                    (&moduleGpioSysPd)
+#define moduleSsspEventflagPD()                 MODULE_OS_GPIOEVENTFLAG_SYSPD
 
-/**
- * @brief   UP signal GPIO.
- */
-#define moduleSsspGpioUP                        moduleGpioSysUartUp
+#define moduleSsspSignalS()                     (&moduleGpioSysSync)
+#define moduleSsspEventflagS()                  MODULE_OS_GPIOEVENTFLAG_SYSSYNC
 
-/**
- * @brief   Event flag for PD signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_PD                MODULE_OS_GPIOEVENTFLAG_SYSPD
-
-/**
- * @brief   Event flag for S signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_S                 MODULE_OS_GPIOEVENTFLAG_SYSSYNC
-
-/**
- * @brief   Event flag for UP signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_UP                MODULE_OS_GPIOEVENTFLAG_SYSUARTUP
+#define moduleSsspSignalUP()                    (&moduleGpioSysUartUp)
+#define moduleSsspEventflagUP()                 MODULE_OS_GPIOEVENTFLAG_SYSUARTUP
 
 /** @} */
 
diff --git a/modules/LightRing_1-0/aosconf.h b/modules/LightRing_1-0/aosconf.h
index 4f1a7e7..747bb25 100644
--- a/modules/LightRing_1-0/aosconf.h
+++ b/modules/LightRing_1-0/aosconf.h
@@ -161,14 +161,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   In order to execute MSI, a broadcast bus (BCB) and according interfaces must be defined.
  */
 #if !defined(OS_CFG_SSSP_MSI)
-  #define AMIROOS_CFG_SSSP_MSI                  false
+  #define AMIROOS_CFG_SSSP_MSI                  true
 #else
   #define AMIROOS_CFG_SSSP_MSI                  OS_CFG_SSSP_MSI
 #endif
 
 /**
  * @brief   Width of the @p aos_sssp_moduleid_t type.
- * @details Possible settings are 8, 16 and 32.
+ * @details Possible settings are 8, 16, 32 and 64.
  */
 #if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
   #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
diff --git a/modules/LightRing_1-0/module.c b/modules/LightRing_1-0/module.c
index 73c8281..1d91d2e 100644
--- a/modules/LightRing_1-0/module.c
+++ b/modules/LightRing_1-0/module.c
@@ -24,7 +24,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#include "module.h"
+#include <amiroos.h>
+
+#include <string.h>
 
 /*===========================================================================*/
 /**
@@ -244,6 +246,67 @@ ROMCONST char* moduleShellPrompt = "LightRing";
  */
 /*===========================================================================*/
 
+#if ((AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MSI == true)) || defined(__DOXYGEN__)
+
+/* some local definitions */
+// maximum number of bytes per CAN frame
+#define CAN_BYTES_PER_FRAME                     8
+// identifier (as dominant as possible)
+#define MSI_BCBMSG_CANID                        0
+
+aos_ssspbcbstatus_t moduleSsspBcbTransmit(const uint8_t* buffer, size_t length)
+{
+  aosDbgCheck(buffer != NULL);
+  aosDbgCheck(length > 0 && length <= CAN_BYTES_PER_FRAME);
+
+  // local variables
+  CANTxFrame frame;
+
+  // setup the common parts of the message frame
+  frame.DLC = (uint8_t)length;
+  frame.RTR = CAN_RTR_DATA;
+  frame.IDE = CAN_IDE_STD;
+  frame.SID = MSI_BCBMSG_CANID;
+  memcpy(frame.data8, buffer, length);
+
+  // sent the frame and return
+  return (canTransmitTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, TIME_IMMEDIATE) == MSG_OK) ? AOS_SSSP_BCB_SUCCESS : AOS_SSSP_BCB_ERROR;
+}
+
+aos_ssspbcbstatus_t moduleSsspBcbReceive(uint8_t* buffer, size_t length)
+{
+  aosDbgCheck(buffer != NULL);
+  aosDbgCheck(length > 0 && length <= CAN_BYTES_PER_FRAME);
+
+  // local variables
+  CANRxFrame frame;
+
+  // receive a frame and check for errors
+  if (canReceiveTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, TIME_IMMEDIATE) == MSG_OK) {
+    // a correct frame was received
+    if (frame.DLC == length &&
+        frame.RTR == CAN_RTR_DATA &&
+        frame.IDE == CAN_IDE_STD &&
+        frame.SID == MSI_BCBMSG_CANID) {
+      // success: fetch the data and return
+      memcpy(buffer, frame.data8, length);
+      return AOS_SSSP_BCB_SUCCESS;
+    }
+    // an unexpected frame was received
+    else {
+      return AOS_SSSP_BCB_INVALIDMSG;
+    }
+  } else {
+    // failure: return with error
+    return AOS_SSSP_BCB_ERROR;
+  }
+}
+
+#undef MSI_BCBMSG_CANID
+#undef CAN_BYTES_PER_FRAME
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MSI == true) */
+
 /** @} */
 
 /*===========================================================================*/
diff --git a/modules/LightRing_1-0/module.h b/modules/LightRing_1-0/module.h
index 91234b5..d633309 100644
--- a/modules/LightRing_1-0/module.h
+++ b/modules/LightRing_1-0/module.h
@@ -266,35 +266,14 @@ extern ROMCONST char* moduleShellPrompt;
  */
 /*===========================================================================*/
 
-/**
- * @brief   PD signal GPIO.
- */
-#define moduleSsspGpioPD                        moduleGpioSysPd
-
-/**
- * @brief   S signal GPIO.
- */
-#define moduleSsspGpioS                         moduleGpioSysSync
+#define moduleSsspSignalPD()                    (&moduleGpioSysPd)
+#define moduleSsspEventflagPD()                 MODULE_OS_GPIOEVENTFLAG_SYSPD
 
-/**
- * @brief   DN signal GPIO.
- */
-#define moduleSsspGpioDN                        moduleGpioSysUartDn
+#define moduleSsspSignalS()                     (&moduleGpioSysSync)
+#define moduleSsspEventflagS()                  MODULE_OS_GPIOEVENTFLAG_SYSSYNC
 
-/**
- * @brief   Event flag for PD signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_PD                MODULE_OS_GPIOEVENTFLAG_SYSPD
-
-/**
- * @brief   Event flag for S signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_S                 MODULE_OS_GPIOEVENTFLAG_SYSSYNC
-
-/**
- * @brief   Event flag for DN signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_DN                MODULE_OS_GPIOEVENTFLAG_SYSUARTDN
+#define moduleSsspSignalDN()                    (&moduleGpioSysUartDn)
+#define moduleSsspEventflagDN()                 MODULE_OS_GPIOEVENTFLAG_SYSUARTDN
 
 /** @} */
 
diff --git a/modules/LightRing_1-2/aosconf.h b/modules/LightRing_1-2/aosconf.h
index af0db51..66eddd5 100644
--- a/modules/LightRing_1-2/aosconf.h
+++ b/modules/LightRing_1-2/aosconf.h
@@ -161,14 +161,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   In order to execute MSI, a broadcast bus (BCB) and according interfaces must be defined.
  */
 #if !defined(OS_CFG_SSSP_MSI)
-  #define AMIROOS_CFG_SSSP_MSI                  false
+  #define AMIROOS_CFG_SSSP_MSI                  true
 #else
   #define AMIROOS_CFG_SSSP_MSI                  OS_CFG_SSSP_MSI
 #endif
 
 /**
  * @brief   Width of the @p aos_sssp_moduleid_t type.
- * @details Possible settings are 8, 16 and 32.
+ * @details Possible settings are 8, 16, 32 and 64.
  */
 #if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
   #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
diff --git a/modules/LightRing_1-2/module.c b/modules/LightRing_1-2/module.c
index d142636..afed4fb 100644
--- a/modules/LightRing_1-2/module.c
+++ b/modules/LightRing_1-2/module.c
@@ -24,7 +24,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#include "module.h"
+#include <amiroos.h>
+
+#include <string.h>
 
 /*===========================================================================*/
 /**
@@ -522,6 +524,67 @@ ROMCONST char* moduleShellPrompt = "LightRing";
  */
 /*===========================================================================*/
 
+#if ((AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MSI == true)) || defined(__DOXYGEN__)
+
+/* some local definitions */
+// maximum number of bytes per CAN frame
+#define CAN_BYTES_PER_FRAME                     8
+// identifier (as dominant as possible)
+#define MSI_BCBMSG_CANID                        0
+
+aos_ssspbcbstatus_t moduleSsspBcbTransmit(const uint8_t* buffer, size_t length)
+{
+  aosDbgCheck(buffer != NULL);
+  aosDbgCheck(length > 0 && length <= CAN_BYTES_PER_FRAME);
+
+  // local variables
+  CANTxFrame frame;
+
+  // setup the common parts of the message frame
+  frame.DLC = (uint8_t)length;
+  frame.RTR = CAN_RTR_DATA;
+  frame.IDE = CAN_IDE_STD;
+  frame.SID = MSI_BCBMSG_CANID;
+  memcpy(frame.data8, buffer, length);
+
+  // sent the frame and return
+  return (canTransmitTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, TIME_IMMEDIATE) == MSG_OK) ? AOS_SSSP_BCB_SUCCESS : AOS_SSSP_BCB_ERROR;
+}
+
+aos_ssspbcbstatus_t moduleSsspBcbReceive(uint8_t* buffer, size_t length)
+{
+  aosDbgCheck(buffer != NULL);
+  aosDbgCheck(length > 0 && length <= CAN_BYTES_PER_FRAME);
+
+  // local variables
+  CANRxFrame frame;
+
+  // receive a frame and check for errors
+  if (canReceiveTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, TIME_IMMEDIATE) == MSG_OK) {
+    // a correct frame was received
+    if (frame.DLC == length &&
+        frame.RTR == CAN_RTR_DATA &&
+        frame.IDE == CAN_IDE_STD &&
+        frame.SID == MSI_BCBMSG_CANID) {
+      // success: fetch the data and return
+      memcpy(buffer, frame.data8, length);
+      return AOS_SSSP_BCB_SUCCESS;
+    }
+    // an unexpected frame was received
+    else {
+      return AOS_SSSP_BCB_INVALIDMSG;
+    }
+  } else {
+    // failure: return with error
+    return AOS_SSSP_BCB_ERROR;
+  }
+}
+
+#undef MSI_BCBMSG_CANID
+#undef CAN_BYTES_PER_FRAME
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MSI == true) */
+
 /** @} */
 
 /*===========================================================================*/
diff --git a/modules/LightRing_1-2/module.h b/modules/LightRing_1-2/module.h
index ac44ae5..1c93cec 100644
--- a/modules/LightRing_1-2/module.h
+++ b/modules/LightRing_1-2/module.h
@@ -413,45 +413,14 @@ extern ROMCONST char* moduleShellPrompt;
  */
 /*===========================================================================*/
 
-/**
- * @brief   PD signal GPIO.
- */
-#define moduleSsspGpioPD                        moduleGpioSysPd
+#define moduleSsspSignalPD()                    (&moduleGpioSysPd)
+#define moduleSsspEventflagPD()                 MODULE_OS_GPIOEVENTFLAG_SYSPD
 
-/**
- * @brief   S signal GPIO.
- */
-#define moduleSsspGpioS                         moduleGpioSysSync
+#define moduleSsspSignalS()                     (&moduleGpioSysSync)
+#define moduleSsspEventflagS()                  MODULE_OS_GPIOEVENTFLAG_SYSSYNC
 
-/**
- * @brief   UP signal GPIO.
- */
-#define moduleSsspGpioUP                        moduleGpioSysUartUp
-
-/**
- * @brief   DN signal GPIO.
- */
-#define moduleSsspGpioDN                        moduleGpioSysUartDn
-
-/**
- * @brief   Event flag for PD signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_PD                MODULE_OS_GPIOEVENTFLAG_SYSPD
-
-/**
- * @brief   Event flag for S signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_S                 MODULE_OS_GPIOEVENTFLAG_SYSSYNC
-
-/**
- * @brief   Event flag for UP signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_UP                MODULE_OS_GPIOEVENTFLAGS_SYSUARTUP
-
-/**
- * @brief   Event flag for DN signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_DN                MODULE_OS_GPIOEVENTFLAG_SYSUARTDN
+#define moduleSsspSignalDN()                    (&moduleGpioSysUartDn)
+#define moduleSsspEventflagDN()                 MODULE_OS_GPIOEVENTFLAG_SYSUARTDN
 
 /** @} */
 
diff --git a/modules/NUCLEO-F103RB/aosconf.h b/modules/NUCLEO-F103RB/aosconf.h
index 54e87ec..605f402 100644
--- a/modules/NUCLEO-F103RB/aosconf.h
+++ b/modules/NUCLEO-F103RB/aosconf.h
@@ -168,7 +168,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 /**
  * @brief   Width of the @p aos_sssp_moduleid_t type.
- * @details Possible settings are 8, 16 and 32.
+ * @details Possible settings are 8, 16, 32 and 64.
  */
 #if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
   #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
diff --git a/modules/NUCLEO-F103RB/module.h b/modules/NUCLEO-F103RB/module.h
index 89ce887..4a20151 100644
--- a/modules/NUCLEO-F103RB/module.h
+++ b/modules/NUCLEO-F103RB/module.h
@@ -275,9 +275,7 @@ extern ROMCONST char* moduleShellPrompt;
 /*===========================================================================*/
 
 #if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
-
-// SSSP is not yet supported on this module
-
+  #error "SSSP is not supported on this module."
 #endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 
 /** @} */
diff --git a/modules/NUCLEO-F401RE/aosconf.h b/modules/NUCLEO-F401RE/aosconf.h
index 3ebcf04..b0729a7 100644
--- a/modules/NUCLEO-F401RE/aosconf.h
+++ b/modules/NUCLEO-F401RE/aosconf.h
@@ -168,7 +168,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 /**
  * @brief   Width of the @p aos_sssp_moduleid_t type.
- * @details Possible settings are 8, 16 and 32.
+ * @details Possible settings are 8, 16, 32 and 64.
  */
 #if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
   #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
diff --git a/modules/NUCLEO-F401RE/module.c b/modules/NUCLEO-F401RE/module.c
index bcc71fd..676b220 100644
--- a/modules/NUCLEO-F401RE/module.c
+++ b/modules/NUCLEO-F401RE/module.c
@@ -24,7 +24,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#include "module.h"
+#include <amiroos.h>
 
 /*===========================================================================*/
 /**
diff --git a/modules/NUCLEO-F401RE/module.h b/modules/NUCLEO-F401RE/module.h
index a3d398c..db71744 100644
--- a/modules/NUCLEO-F401RE/module.h
+++ b/modules/NUCLEO-F401RE/module.h
@@ -152,9 +152,7 @@ extern ROMCONST char* moduleShellPrompt;
 /*===========================================================================*/
 
 #if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
-
-// SSSP is not yet supported on this module
-
+  #error "SSSP is not supported on this module."
 #endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 
 /** @} */
diff --git a/modules/NUCLEO-F767ZI/aosconf.h b/modules/NUCLEO-F767ZI/aosconf.h
index 099f033..dec9743 100644
--- a/modules/NUCLEO-F767ZI/aosconf.h
+++ b/modules/NUCLEO-F767ZI/aosconf.h
@@ -168,7 +168,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 /**
  * @brief   Width of the @p aos_sssp_moduleid_t type.
- * @details Possible settings are 8, 16 and 32.
+ * @details Possible settings are 8, 16, 32 and 64.
  */
 #if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
   #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
diff --git a/modules/NUCLEO-F767ZI/module.h b/modules/NUCLEO-F767ZI/module.h
index 3cfec3c..e8fc975 100644
--- a/modules/NUCLEO-F767ZI/module.h
+++ b/modules/NUCLEO-F767ZI/module.h
@@ -164,9 +164,7 @@ extern ROMCONST char* moduleShellPrompt;
 /*===========================================================================*/
 
 #if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
-
-// SSSP is not yet supported on this module
-
+  #error "SSSP is not supported on this module."
 #endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 
 /** @} */
diff --git a/modules/NUCLEO-L476RG/aosconf.h b/modules/NUCLEO-L476RG/aosconf.h
index 862a882..47031f4 100644
--- a/modules/NUCLEO-L476RG/aosconf.h
+++ b/modules/NUCLEO-L476RG/aosconf.h
@@ -168,7 +168,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 /**
  * @brief   Width of the @p aos_sssp_moduleid_t type.
- * @details Possible settings are 8, 16 and 32.
+ * @details Possible settings are 8, 16, 32 and 64.
  */
 #if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
   #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
diff --git a/modules/NUCLEO-L476RG/module.h b/modules/NUCLEO-L476RG/module.h
index 1c4b8bf..b58008e 100644
--- a/modules/NUCLEO-L476RG/module.h
+++ b/modules/NUCLEO-L476RG/module.h
@@ -207,9 +207,7 @@ extern ROMCONST char* moduleShellPrompt;
 /*===========================================================================*/
 
 #if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
-
-// SSSP is not yet supported on this module
-
+  #error "SSSP is not supported on this module."
 #endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 
 /** @} */
diff --git a/modules/PowerManagement_1-1/aosconf.h b/modules/PowerManagement_1-1/aosconf.h
index caa6515..9e53959 100644
--- a/modules/PowerManagement_1-1/aosconf.h
+++ b/modules/PowerManagement_1-1/aosconf.h
@@ -161,14 +161,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   In order to execute MSI, a broadcast bus (BCB) and according interfaces must be defined.
  */
 #if !defined(OS_CFG_SSSP_MSI)
-  #define AMIROOS_CFG_SSSP_MSI                  false
+  #define AMIROOS_CFG_SSSP_MSI                  true
 #else
   #define AMIROOS_CFG_SSSP_MSI                  OS_CFG_SSSP_MSI
 #endif
 
 /**
  * @brief   Width of the @p aos_sssp_moduleid_t type.
- * @details Possible settings are 8, 16 and 32.
+ * @details Possible settings are 8, 16, 32 and 64.
  */
 #if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
   #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
diff --git a/modules/PowerManagement_1-1/module.c b/modules/PowerManagement_1-1/module.c
index ad30a16..6246a6e 100644
--- a/modules/PowerManagement_1-1/module.c
+++ b/modules/PowerManagement_1-1/module.c
@@ -24,7 +24,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#include "module.h"
+#include <amiroos.h>
+
+#include <string.h>
 
 /*===========================================================================*/
 /**
@@ -535,6 +537,67 @@ ROMCONST char* moduleShellPrompt = "PowerManagement";
  */
 /*===========================================================================*/
 
+#if ((AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MSI == true)) || defined(__DOXYGEN__)
+
+/* some local definitions */
+// maximum number of bytes per CAN frame
+#define CAN_BYTES_PER_FRAME                     8
+// identifier (as dominant as possible)
+#define MSI_BCBMSG_CANID                        0
+
+aos_ssspbcbstatus_t moduleSsspBcbTransmit(const uint8_t* buffer, size_t length)
+{
+  aosDbgCheck(buffer != NULL);
+  aosDbgCheck(length > 0 && length <= CAN_BYTES_PER_FRAME);
+
+  // local variables
+  CANTxFrame frame;
+
+  // setup the common parts of the message frame
+  frame.DLC = (uint8_t)length;
+  frame.RTR = CAN_RTR_DATA;
+  frame.IDE = CAN_IDE_STD;
+  frame.SID = MSI_BCBMSG_CANID;
+  memcpy(frame.data8, buffer, length);
+
+  // sent the frame and return
+  return (canTransmitTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, TIME_IMMEDIATE) == MSG_OK) ? AOS_SSSP_BCB_SUCCESS : AOS_SSSP_BCB_ERROR;
+}
+
+aos_ssspbcbstatus_t moduleSsspBcbReceive(uint8_t* buffer, size_t length)
+{
+  aosDbgCheck(buffer != NULL);
+  aosDbgCheck(length > 0 && length <= CAN_BYTES_PER_FRAME);
+
+  // local variables
+  CANRxFrame frame;
+
+  // receive a frame and check for errors
+  if (canReceiveTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, TIME_IMMEDIATE) == MSG_OK) {
+    // a correct frame was received
+    if (frame.DLC == length &&
+        frame.RTR == CAN_RTR_DATA &&
+        frame.IDE == CAN_IDE_STD &&
+        frame.SID == MSI_BCBMSG_CANID) {
+      // success: fetch the data and return
+      memcpy(buffer, frame.data8, length);
+      return AOS_SSSP_BCB_SUCCESS;
+    }
+    // an unexpected frame was received
+    else {
+      return AOS_SSSP_BCB_INVALIDMSG;
+    }
+  } else {
+    // failure: return with error
+    return AOS_SSSP_BCB_ERROR;
+  }
+}
+
+#undef MSI_BCBMSG_CANID
+#undef CAN_BYTES_PER_FRAME
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MSI == true) */
+
 /** @} */
 
 /*===========================================================================*/
diff --git a/modules/PowerManagement_1-1/module.h b/modules/PowerManagement_1-1/module.h
index e33ba03..974a71b 100644
--- a/modules/PowerManagement_1-1/module.h
+++ b/modules/PowerManagement_1-1/module.h
@@ -542,45 +542,17 @@ extern ROMCONST char* moduleShellPrompt;
  */
 /*===========================================================================*/
 
-/**
- * @brief   PD signal GPIO.
- */
-#define moduleSsspGpioPD                        moduleGpioSysPd
-
-/**
- * @brief   S signal GPIO.
- */
-#define moduleSsspGpioS                         moduleGpioSysSync
-
-/**
- * @brief   DN signal GPIO.
- */
-#define moduleSsspGpioDN                        moduleGpioSysUartDn
-
-/**
- * @brief   UP signal GPIO.
- */
-#define moduleSsspGpioUP                        moduleGpioSysUartUp
+#define moduleSsspSignalPD()                    (&moduleGpioSysPd)
+#define moduleSsspEventflagPD()                 MODULE_OS_GPIOEVENTFLAG_SYSPD
 
-/**
- * @brief   Event flag for PD signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_PD                MODULE_OS_GPIOEVENTFLAG_SYSPD
-
-/**
- * @brief   Event flag for S signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_S                 MODULE_OS_GPIOEVENTFLAG_SYSSYNC
+#define moduleSsspSignalS()                     (&moduleGpioSysSync)
+#define moduleSsspEventflagS()                  MODULE_OS_GPIOEVENTFLAG_SYSSYNC
 
-/**
- * @brief   Event flag for UP signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_UP                MODULE_OS_GPIOEVENTFLAG_SYSUARTUP
+#define moduleSsspSignalUP()                    (&moduleGpioSysUartUp)
+#define moduleSsspEventflagUP()                 MODULE_OS_GPIOEVENTFLAG_SYSUARTUP
 
-/**
- * @brief   Event flag for DN signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_DN                MODULE_OS_GPIOEVENTFLAG_SYSUARTDN
+#define moduleSsspSignalDN()                    (&moduleGpioSysUartDn)
+#define moduleSsspEventflagDN()                 MODULE_OS_GPIOEVENTFLAG_SYSUARTDN
 
 /** @} */
 
diff --git a/modules/PowerManagement_1-2/aosconf.h b/modules/PowerManagement_1-2/aosconf.h
index 71bf84e..0b1fa46 100644
--- a/modules/PowerManagement_1-2/aosconf.h
+++ b/modules/PowerManagement_1-2/aosconf.h
@@ -161,14 +161,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   In order to execute MSI, a broadcast bus (BCB) and according interfaces must be defined.
  */
 #if !defined(OS_CFG_SSSP_MSI)
-  #define AMIROOS_CFG_SSSP_MSI                  false
+  #define AMIROOS_CFG_SSSP_MSI                  true
 #else
   #define AMIROOS_CFG_SSSP_MSI                  OS_CFG_SSSP_MSI
 #endif
 
 /**
  * @brief   Width of the @p aos_sssp_moduleid_t type.
- * @details Possible settings are 8, 16 and 32.
+ * @details Possible settings are 8, 16, 32 and 64.
  */
 #if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
   #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
diff --git a/modules/PowerManagement_1-2/module.c b/modules/PowerManagement_1-2/module.c
index e962413..7d46aa2 100644
--- a/modules/PowerManagement_1-2/module.c
+++ b/modules/PowerManagement_1-2/module.c
@@ -24,7 +24,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#include "module.h"
+#include <amiroos.h>
+
+#include <string.h>
 
 /*===========================================================================*/
 /**
@@ -550,6 +552,67 @@ ROMCONST char* moduleShellPrompt = "PowerManagement";
  */
 /*===========================================================================*/
 
+#if ((AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MSI == true)) || defined(__DOXYGEN__)
+
+/* some local definitions */
+// maximum number of bytes per CAN frame
+#define CAN_BYTES_PER_FRAME                     8
+// identifier (as dominant as possible)
+#define MSI_BCBMSG_CANID                        0
+
+aos_ssspbcbstatus_t moduleSsspBcbTransmit(const uint8_t* buffer, size_t length)
+{
+  aosDbgCheck(buffer != NULL);
+  aosDbgCheck(length > 0 && length <= CAN_BYTES_PER_FRAME);
+
+  // local variables
+  CANTxFrame frame;
+
+  // setup the common parts of the message frame
+  frame.DLC = (uint8_t)length;
+  frame.RTR = CAN_RTR_DATA;
+  frame.IDE = CAN_IDE_STD;
+  frame.SID = MSI_BCBMSG_CANID;
+  memcpy(frame.data8, buffer, length);
+
+  // sent the frame and return
+  return (canTransmitTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, TIME_IMMEDIATE) == MSG_OK) ? AOS_SSSP_BCB_SUCCESS : AOS_SSSP_BCB_ERROR;
+}
+
+aos_ssspbcbstatus_t moduleSsspBcbReceive(uint8_t* buffer, size_t length)
+{
+  aosDbgCheck(buffer != NULL);
+  aosDbgCheck(length > 0 && length <= CAN_BYTES_PER_FRAME);
+
+  // local variables
+  CANRxFrame frame;
+
+  // receive a frame and check for errors
+  if (canReceiveTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, TIME_IMMEDIATE) == MSG_OK) {
+    // a correct frame was received
+    if (frame.DLC == length &&
+        frame.RTR == CAN_RTR_DATA &&
+        frame.IDE == CAN_IDE_STD &&
+        frame.SID == MSI_BCBMSG_CANID) {
+      // success: fetch the data and return
+      memcpy(buffer, frame.data8, length);
+      return AOS_SSSP_BCB_SUCCESS;
+    }
+    // an unexpected frame was received
+    else {
+      return AOS_SSSP_BCB_INVALIDMSG;
+    }
+  } else {
+    // failure: return with error
+    return AOS_SSSP_BCB_ERROR;
+  }
+}
+
+#undef MSI_BCBMSG_CANID
+#undef CAN_BYTES_PER_FRAME
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MSI == true) */
+
 /** @} */
 
 /*===========================================================================*/
diff --git a/modules/PowerManagement_1-2/module.h b/modules/PowerManagement_1-2/module.h
index bba083b..53185ac 100644
--- a/modules/PowerManagement_1-2/module.h
+++ b/modules/PowerManagement_1-2/module.h
@@ -547,45 +547,17 @@ extern ROMCONST char* moduleShellPrompt;
  */
 /*===========================================================================*/
 
-/**
- * @brief   PD signal GPIO.
- */
-#define moduleSsspGpioPD                        moduleGpioSysPd
-
-/**
- * @brief   S signal GPIO.
- */
-#define moduleSsspGpioS                         moduleGpioSysSync
-
-/**
- * @brief   UP signal GPIO.
- */
-#define moduleSsspGpioUP                        moduleGpioSysUartUp
-
-/**
- * @brief   DN signal GPIO.
- */
-#define moduleSsspGpioDN                        moduleGpioSysUartDn
+#define moduleSsspSignalPD()                    (&moduleGpioSysPd)
+#define moduleSsspEventflagPD()                 MODULE_OS_GPIOEVENTFLAG_SYSPD
 
-/**
- * @brief   Event flag for PD signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_PD                MODULE_OS_GPIOEVENTFLAG_SYSPD
-
-/**
- * @brief   Event flag for S signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_S                 MODULE_OS_GPIOEVENTFLAG_SYSSYNC
+#define moduleSsspSignalS()                     (&moduleGpioSysSync)
+#define moduleSsspEventflagS()                  MODULE_OS_GPIOEVENTFLAG_SYSSYNC
 
-/**
- * @brief   Event flag for UP signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_UP                MODULE_OS_GPIOEVENTFLAG_SYSUARTUP
+#define moduleSsspSignalUP()                    (&moduleGpioSysUartUp)
+#define moduleSsspEventflagUP()                 MODULE_OS_GPIOEVENTFLAG_SYSUARTUP
 
-/**
- * @brief   Event flag for DN signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_DN                MODULE_OS_GPIOEVENTFLAG_SYSUARTDN
+#define moduleSsspSignalDN()                    (&moduleGpioSysUartDn)
+#define moduleSsspEventflagDN()                 MODULE_OS_GPIOEVENTFLAG_SYSUARTDN
 
 /** @} */
 
diff --git a/modules/STM32F407G-DISC1/aosconf.h b/modules/STM32F407G-DISC1/aosconf.h
index 9f9cece..a7258c7 100644
--- a/modules/STM32F407G-DISC1/aosconf.h
+++ b/modules/STM32F407G-DISC1/aosconf.h
@@ -168,7 +168,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 /**
  * @brief   Width of the @p aos_sssp_moduleid_t type.
- * @details Possible settings are 8, 16 and 32.
+ * @details Possible settings are 8, 16, 32 and 64.
  */
 #if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
   #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
diff --git a/modules/STM32F407G-DISC1/module.c b/modules/STM32F407G-DISC1/module.c
index 8949a9b..b30dcea 100644
--- a/modules/STM32F407G-DISC1/module.c
+++ b/modules/STM32F407G-DISC1/module.c
@@ -24,7 +24,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#include "module.h"
+#include <amiroos.h>
 
 /*===========================================================================*/
 /**
diff --git a/modules/STM32F407G-DISC1/module.h b/modules/STM32F407G-DISC1/module.h
index 168719a..fbf2046 100644
--- a/modules/STM32F407G-DISC1/module.h
+++ b/modules/STM32F407G-DISC1/module.h
@@ -197,9 +197,7 @@ extern ROMCONST char* moduleShellPrompt;
 /*===========================================================================*/
 
 #if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
-
-// SSSP is not yet supported on this module
-
+  #error "SSSP is not supported on this module."
 #endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 
 /** @} */
